/* This file was generated by SableCC (http://www.sablecc.org/). */

package astdemo.analysis;

import astdemo.node.*;
/**
 * Visitor for AST nodes. Contains one method per node class. 
 * 
 * @param <OutT> Return type of visitation methods
 * @param <InT> Type of a helper object passed into visitation methods
 */
public interface GenericAnalysis<OutT,InT> extends GenericSwitch<OutT,InT>
{
	/**
	 * Do something with the Start node. 
	 *
	 * @param node the Start node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value (or null)
	 */
    OutT caseStart(Start node, InT helper);
	/**
	 * Do something with a AAddExpr node. 
	 *
	 * @param node the AAddExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseAAddExpr(AAddExpr node, InT helper);
	/**
	 * Do something with a ASubExpr node. 
	 *
	 * @param node the ASubExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseASubExpr(ASubExpr node, InT helper);
	/**
	 * Do something with a AMulExpr node. 
	 *
	 * @param node the AMulExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseAMulExpr(AMulExpr node, InT helper);
	/**
	 * Do something with a ADivExpr node. 
	 *
	 * @param node the ADivExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseADivExpr(ADivExpr node, InT helper);
	/**
	 * Do something with a ANumberExpr node. 
	 *
	 * @param node the ANumberExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseANumberExpr(ANumberExpr node, InT helper);
	/**
	 * Do something with a AConstantExpr node. 
	 *
	 * @param node the AConstantExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseAConstantExpr(AConstantExpr node, InT helper);
	/**
	 * Do something with a AFunctionExpr node. 
	 *
	 * @param node the AFunctionExpr node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseAFunctionExpr(AFunctionExpr node, InT helper);

	/**
	 * Do something with a TWhiteSpace node. 
	 *
	 * @param node the TWhiteSpace node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTWhiteSpace(TWhiteSpace node, InT helper);
	/**
	 * Do something with a TAdd node. 
	 *
	 * @param node the TAdd node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTAdd(TAdd node, InT helper);
	/**
	 * Do something with a TSub node. 
	 *
	 * @param node the TSub node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTSub(TSub node, InT helper);
	/**
	 * Do something with a TMul node. 
	 *
	 * @param node the TMul node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTMul(TMul node, InT helper);
	/**
	 * Do something with a TDiv node. 
	 *
	 * @param node the TDiv node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTDiv(TDiv node, InT helper);
	/**
	 * Do something with a TLeftParen node. 
	 *
	 * @param node the TLeftParen node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTLeftParen(TLeftParen node, InT helper);
	/**
	 * Do something with a TRightParen node. 
	 *
	 * @param node the TRightParen node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTRightParen(TRightParen node, InT helper);
	/**
	 * Do something with a TComma node. 
	 *
	 * @param node the TComma node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTComma(TComma node, InT helper);
	/**
	 * Do something with a TNumber node. 
	 *
	 * @param node the TNumber node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTNumber(TNumber node, InT helper);
	/**
	 * Do something with a TIdentifier node. 
	 *
	 * @param node the TIdentifier node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseTIdentifier(TIdentifier node, InT helper);
	/**
	 * Do something with the EOF node (the last child of the Star node) 
	 *
	 * @param node the EOF node
	 * @param helper some helper object (e.g. a variable binding context)
	 * @return some OutT value computed from the node (or null)
	 */
    OutT caseEOF(EOF node, InT helper);
}
