/* This file was generated by SableCC (http://www.sablecc.org/). */

package astdemo.analysis;

import java.util.*;
import astdemo.node.*;

/**
 * Base class for depth-first traversal visitors which visit
 * the children right-to-left. 
 *
 * @param <OutT> Return type of visitation methods
 * @param <InT> Type of a helper object passed into visitation methods
 */
public class GenericReversedDepthFirstAdapter<OutT,InT> extends GenericAnalysisAdapter<OutT,InT>
{
    protected void inStart(Start node, InT helper)
    {
        defaultIn(node, helper);
    }

    protected OutT outStart(Start node, InT helper)
    {
       return defaultOut(node, helper);
    }

    protected void defaultIn(@SuppressWarnings("unused") Node node, InT helper)
    {
        // Do nothing
    }

    protected OutT defaultOut(@SuppressWarnings("unused") Node node, InT helper)
    {
        // Do nothing
        return null;
    }

    @Override
    public OutT caseStart(Start node, InT helper)
    {
        inStart(node, helper);
        node.getEOF().apply(this, helper);
        node.getPExpr().apply(this, helper);
       return outStart(node,helper);
    }

	/**
	 * Prepare for visiting a AAddExpr.
	 * @param node the AAddExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inAAddExpr(AAddExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a AAddExpr.
	 * @param node the AAddExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outAAddExpr(AAddExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a AAddExpr. If you don't override this,
	 * this method will call inAAddExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outAAddExpr and return its result.
	 * 
	 * @param node the AAddExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseAAddExpr(AAddExpr node, InT helper)
    {
        inAAddExpr(node, helper);
        if(node.getRight() != null)
        {
            node.getRight().apply(this, helper);
        }
        if(node.getLeft() != null)
        {
            node.getLeft().apply(this, helper);
        }
        return outAAddExpr(node,helper);
    }

	/**
	 * Prepare for visiting a ASubExpr.
	 * @param node the ASubExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inASubExpr(ASubExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a ASubExpr.
	 * @param node the ASubExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outASubExpr(ASubExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a ASubExpr. If you don't override this,
	 * this method will call inASubExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outASubExpr and return its result.
	 * 
	 * @param node the ASubExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseASubExpr(ASubExpr node, InT helper)
    {
        inASubExpr(node, helper);
        if(node.getRight() != null)
        {
            node.getRight().apply(this, helper);
        }
        if(node.getLeft() != null)
        {
            node.getLeft().apply(this, helper);
        }
        return outASubExpr(node,helper);
    }

	/**
	 * Prepare for visiting a AMulExpr.
	 * @param node the AMulExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inAMulExpr(AMulExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a AMulExpr.
	 * @param node the AMulExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outAMulExpr(AMulExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a AMulExpr. If you don't override this,
	 * this method will call inAMulExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outAMulExpr and return its result.
	 * 
	 * @param node the AMulExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseAMulExpr(AMulExpr node, InT helper)
    {
        inAMulExpr(node, helper);
        if(node.getRight() != null)
        {
            node.getRight().apply(this, helper);
        }
        if(node.getLeft() != null)
        {
            node.getLeft().apply(this, helper);
        }
        return outAMulExpr(node,helper);
    }

	/**
	 * Prepare for visiting a ADivExpr.
	 * @param node the ADivExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inADivExpr(ADivExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a ADivExpr.
	 * @param node the ADivExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outADivExpr(ADivExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a ADivExpr. If you don't override this,
	 * this method will call inADivExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outADivExpr and return its result.
	 * 
	 * @param node the ADivExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseADivExpr(ADivExpr node, InT helper)
    {
        inADivExpr(node, helper);
        if(node.getRight() != null)
        {
            node.getRight().apply(this, helper);
        }
        if(node.getLeft() != null)
        {
            node.getLeft().apply(this, helper);
        }
        return outADivExpr(node,helper);
    }

	/**
	 * Prepare for visiting a ANumberExpr.
	 * @param node the ANumberExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inANumberExpr(ANumberExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a ANumberExpr.
	 * @param node the ANumberExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outANumberExpr(ANumberExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a ANumberExpr. If you don't override this,
	 * this method will call inANumberExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outANumberExpr and return its result.
	 * 
	 * @param node the ANumberExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseANumberExpr(ANumberExpr node, InT helper)
    {
        inANumberExpr(node, helper);
        if(node.getNumber() != null)
        {
            node.getNumber().apply(this, helper);
        }
        return outANumberExpr(node,helper);
    }

	/**
	 * Prepare for visiting a AConstantExpr.
	 * @param node the AConstantExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inAConstantExpr(AConstantExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a AConstantExpr.
	 * @param node the AConstantExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outAConstantExpr(AConstantExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a AConstantExpr. If you don't override this,
	 * this method will call inAConstantExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outAConstantExpr and return its result.
	 * 
	 * @param node the AConstantExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseAConstantExpr(AConstantExpr node, InT helper)
    {
        inAConstantExpr(node, helper);
        if(node.getName() != null)
        {
            node.getName().apply(this, helper);
        }
        return outAConstantExpr(node,helper);
    }

	/**
	 * Prepare for visiting a AFunctionExpr.
	 * @param node the AFunctionExpr node to visit
	 * @param helper the helper object
	 */ 
    protected void inAFunctionExpr(AFunctionExpr node, InT helper)
    {
        defaultIn(node, helper);
    }

	/**
	 * Do something after visiting a AFunctionExpr.
	 * @param node the AFunctionExpr node that has been visited
	 * @param helper the helper object
	 * @return something computed from node (or null)
	 */ 
    protected OutT outAFunctionExpr(AFunctionExpr node, InT helper)
    {
      	return defaultOut(node,helper);
    }

	/**
	 * Visiting a AFunctionExpr. If you don't override this,
	 * this method will call inAFunctionExpr, followed by 
	 * applying this visitor to every child node (discarding the OutT result),
	 * then call outAFunctionExpr and return its result.
	 * 
	 * @param node the AFunctionExpr node to visit
	 * @param helper the helper object
	 * @return some OutT or null
	 */ 
    @Override
    public OutT caseAFunctionExpr(AFunctionExpr node, InT helper)
    {
        inAFunctionExpr(node, helper);
        {
            List<PExpr> copy = new ArrayList<PExpr>(node.getArgs());
            Collections.reverse(copy);
            for(PExpr e : copy)
            {
                e.apply(this, helper);
            }
        }
        if(node.getName() != null)
        {
            node.getName().apply(this, helper);
        }
        return outAFunctionExpr(node,helper);
    }
}
