/* This file was generated by SableCC (http://www.sablecc.org/). */

package astdemo.parser;

import astdemo.lexer.*;
import astdemo.node.*;
import astdemo.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList<Object> nodeList;

    private final Lexer lexer;
    private final ListIterator<Object> stack = new LinkedList<Object>().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    @SuppressWarnings({"unchecked","unused"})
    private void push(int numstate, ArrayList<Object> listNode) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            // int middle = (low + high) / 2;
            int middle = (low + high) >>> 1;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList<Object> pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    /**
     * DFS for a {@link Node} with line number information.
     * 
     * @param nodeOrList a Node or a list of (lists of...) Node.
     * @return the leftmost node to have line number, or null. 
     */
    Node findLeftmostDescendant(Object nodeOrList) {
    	if(nodeOrList instanceof List){
    		List li = (List) nodeOrList;
    		if(li.isEmpty()){
    			// no, don't search uncle nodes
    			return null;
    		}
    		else {
    			// DFS for first line-numbered Node
    			Iterator it= li.iterator(); 
    			while(it.hasNext()) {
    				Object first = it.next();
    				Node n = findLeftmostDescendant(first);
    				if(n instanceof Node && (n.getLine() != 0)) {
    					return n;
    				}
    			}
    			return null; // no child had a line number, sniff
    		}
    	} 
    	else if(nodeOrList instanceof Node){
    		return (Node) nodeOrList;
    	}
    	else {
    		return null;
    	}
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList<Object> list = new ArrayList<Object>();
		        list.add(this.lexer.next());
                        push(this.action[1], list);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AAddExpr */
		    {
			ArrayList<Object> list = new0();
			push(goTo(0), list);
		    }
		    break;
                    case 1: /* reduce ASubExpr */
		    {
			ArrayList<Object> list = new1();
			push(goTo(0), list);
		    }
		    break;
                    case 2: /* reduce AFactorExpr */
		    {
			ArrayList<Object> list = new2();
			push(goTo(0), list);
		    }
		    break;
                    case 3: /* reduce AMulFactor */
		    {
			ArrayList<Object> list = new3();
			push(goTo(1), list);
		    }
		    break;
                    case 4: /* reduce ADivFactor */
		    {
			ArrayList<Object> list = new4();
			push(goTo(1), list);
		    }
		    break;
                    case 5: /* reduce AValueFactor */
		    {
			ArrayList<Object> list = new5();
			push(goTo(1), list);
		    }
		    break;
                    case 6: /* reduce ANumberValue */
		    {
			ArrayList<Object> list = new6();
			push(goTo(2), list);
		    }
		    break;
                    case 7: /* reduce AParensValue */
		    {
			ArrayList<Object> list = new7();
			push(goTo(2), list);
		    }
		    break;
                    case 8: /* reduce AConstantValue */
		    {
			ArrayList<Object> list = new8();
			push(goTo(2), list);
		    }
		    break;
                    case 9: /* reduce AFunctionValue */
		    {
			ArrayList<Object> list = new9();
			push(goTo(2), list);
		    }
		    break;
                    case 10: /* reduce ASingleArgList */
		    {
			ArrayList<Object> list = new10();
			push(goTo(3), list);
		    }
		    break;
                    case 11: /* reduce AMultipleArgList */
		    {
			ArrayList<Object> list = new11();
			push(goTo(3), list);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PExpr node1 = (PExpr) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new0() /* reduce AAddExpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        PExpr pexprNode3;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList3.get(0);

        pexprNode1 = new AAddExpr(pexprNode2, pexprNode3);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new1() /* reduce ASubExpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        PExpr pexprNode3;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList3.get(0);

        pexprNode1 = new ASubExpr(pexprNode2, pexprNode3);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new2() /* reduce AFactorExpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        pexprNode1 = (PExpr)nodeArrayList1.get(0);
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new3() /* reduce AMulFactor */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        PExpr pexprNode3;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList3.get(0);

        pexprNode1 = new AMulExpr(pexprNode2, pexprNode3);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new4() /* reduce ADivFactor */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        PExpr pexprNode3;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList3.get(0);

        pexprNode1 = new ADivExpr(pexprNode2, pexprNode3);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new5() /* reduce AValueFactor */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        pexprNode1 = (PExpr)nodeArrayList1.get(0);
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new6() /* reduce ANumberValue */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        TNumber tnumberNode2;
        tnumberNode2 = (TNumber)nodeArrayList1.get(0);

        pexprNode1 = new ANumberExpr(tnumberNode2);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new7() /* reduce AParensValue */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        pexprNode1 = (PExpr)nodeArrayList2.get(0);
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new8() /* reduce AConstantValue */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        TIdentifier tidentifierNode2;
        tidentifierNode2 = (TIdentifier)nodeArrayList1.get(0);

        pexprNode1 = new AConstantExpr(tidentifierNode2);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new9() /* reduce AFunctionValue */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        nodesInTextualOrder.push(nodeArrayList4);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                PExpr pexprNode1;
        {
            // Block
        TIdentifier tidentifierNode2;
        LinkedList<Object> listNode4 = new LinkedList<Object>();
        tidentifierNode2 = (TIdentifier)nodeArrayList1.get(0);
        {
            // Block
        LinkedList<Object> listNode3 = new LinkedList<Object>();
        listNode3 = (LinkedList)nodeArrayList3.get(0);
	if(listNode3 != null)
	{
	  listNode4.addAll(listNode3);
	}
        }

        pexprNode1 = new AFunctionExpr(tidentifierNode2, listNode4);

        // tell the new node its line number
        pexprNode1.setLine( concreteLineNumber );
        pexprNode1.setPos( concretePos );
                }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new10() /* reduce ASingleArgList */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                LinkedList<Object> listNode2 = new LinkedList<Object>();
        {
            // Block
        PExpr pexprNode1;
        pexprNode1 = (PExpr)nodeArrayList1.get(0);
	if(pexprNode1 != null)
	{
	  listNode2.add(pexprNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new11() /* reduce AMultipleArgList */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();
        LinkedList nodesInTextualOrder = new LinkedList();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        nodesInTextualOrder.push(nodeArrayList3);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        nodesInTextualOrder.push(nodeArrayList2);
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        nodesInTextualOrder.push(nodeArrayList1);

        // Get line number from a child node as far left as possible
        int concreteLineNumber;
        int concretePos;
        Node leftmostGrandchild = findLeftmostDescendant(nodesInTextualOrder);
        if(leftmostGrandchild != null) {
            concreteLineNumber = leftmostGrandchild.getLine();
            concretePos = leftmostGrandchild.getPos();
        }	
        else {
            concreteLineNumber = 0;
            concretePos = 0;
        }
                LinkedList<Object> listNode3 = new LinkedList<Object>();
        {
            // Block
        PExpr pexprNode1;
        LinkedList<Object> listNode2 = new LinkedList<Object>();
        pexprNode1 = (PExpr)nodeArrayList1.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pexprNode1 != null)
	{
	  listNode3.add(pexprNode1);
	}
	if(listNode2 != null)
	{
	  listNode3.addAll(listNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, ERROR, 1}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 8}, {4, SHIFT, 8}, },
			{{-1, ERROR, 4}, {0, SHIFT, 9}, {1, SHIFT, 10}, {9, ACCEPT, -1}, },
			{{-1, REDUCE, 2}, {2, SHIFT, 11}, {3, SHIFT, 12}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 7}, {0, SHIFT, 9}, {1, SHIFT, 10}, {5, SHIFT, 13}, },
			{{-1, ERROR, 8}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, ERROR, 9}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, ERROR, 10}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, ERROR, 11}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, ERROR, 12}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 10}, {0, SHIFT, 9}, {1, SHIFT, 10}, {6, SHIFT, 20}, },
			{{-1, ERROR, 15}, {5, SHIFT, 21}, },
			{{-1, REDUCE, 0}, {2, SHIFT, 11}, {3, SHIFT, 12}, },
			{{-1, REDUCE, 1}, {2, SHIFT, 11}, {3, SHIFT, 12}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 20}, {4, SHIFT, 1}, {7, SHIFT, 2}, {8, SHIFT, 3}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 11}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 14}, {0, 4}, {1, 7}, },
			{{-1, 5}, {9, 16}, {10, 17}, },
			{{-1, 6}, {11, 18}, {12, 19}, },
			{{-1, 15}, {20, 22}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: '(', number, identifier",
			"expecting: '+', '-', '*', 'div', ')', ',', EOF",
			"expecting: '+', '-', '*', 'div', '(', ')', ',', EOF",
			"expecting: '+', '-', EOF",
			"expecting: '+', '-', ')'",
			"expecting: '+', '-', ')', ','",
			"expecting: ')'",
        };*/
    private static int[] errors;
/*      {
			0, 0, 1, 2, 3, 1, 1, 4, 0, 0, 0, 0, 0, 1, 5, 6, 1, 1, 1, 1, 0, 1, 6, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
